package com.zskk.controller;

import com.jfinal.weixin.sdk.api.ApiConfigKit;
import com.jfinal.weixin.sdk.api.SnsAccessToken;
import com.jfinal.weixin.sdk.jfinal.ApiController;
import com.zskk.model.User;
import com.zskk.service.ServiceFactory;
import com.zskk.service.UserService;
import com.zskk.service.WeixinService;

public class WebBridgeController extends ApiController {

	private static String WEB_BASR_URL = "http://wechat.client.pacsonline.cn/#";
	
	public void testappid() {
		String string = ApiConfigKit.getApiConfig().getAppId();
		System.out.println(string);
		renderText(string);
	}
	
	public void addBinding() {
		this.process(WEB_BASR_URL+"/bind");
	}
	
	public void examList() {
		this.process(WEB_BASR_URL+"/reportList");
	}

	public void aboutUs() {
		this.redirect("http://wechat.pacsonline.cn/pacs_online/html/aboutAs_zskk.html");
	}
	
	private void process(String toUrl) {
		try {
			Object sessionObj = this.getRequest().getSession().getAttribute("pwpSessionObjtest8");
			WeixinService wService = ServiceFactory.getService(WeixinService.class);
			if (sessionObj == null) {
				String code = this.getPara("code");
				if (code == null) {
					String url = wService.getCodeUrl("wxee1c68f8944d357b", getRequest().getRequestURL().toString());
//					String url = wService.getCodeUrl("wx6a54bf0e98ecd2c7", getRequest().getRequestURL().toString());

					this.redirect(url);
					return;
				}
				SnsAccessToken snsAccessToken = wService.getWebAccessToken("wxee1c68f8944d357b", "1bc0128b6bbb3907c3bcf4a1704f2a1f", code);
//				SnsAccessToken snsAccessToken = wService.getWebAccessToken("wx6a54bf0e98ecd2c7", "f4b4e2b054d84157565ace97a43275e8", code);

				UserService uService = ServiceFactory.getService(UserService.class);
				User user = User.dao.findFirst("select * from user where wx_openid=?",snsAccessToken.getOpenid());

				if (user == null && snsAccessToken.getOpenid() != null) {
					user = uService.createWxUser(snsAccessToken.getOpenid());
				}
				if (user != null && user.getWxIcon().isEmpty()) {                     
					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());
				}
				this.getRequest().getSession().setAttribute("pwpSessionObjtest8", user);
				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
				this.redirect(toUrl + uidStr + snsAccessToken.getOpenid());
			} else {
				UserService uService = ServiceFactory.getService(UserService.class);
				User userWechats = (User) sessionObj;
				User users = User.dao.findById(userWechats.getId());
				String uidStr = toUrl.contains("?") ? "&openid=" : "?openid=";
				if (users == null) {
					userWechats = uService.createWxUser(userWechats.getWxOpenid());
				}
				User users2 = User.dao.findFirst("select * from user where wx_openid=?",userWechats.getWxOpenid());
				if (users2 != null && users2.getWxIcon().isEmpty()) {
//					uService.getUserInfo(userWechats.getWxOpenid());
//					wService.getWebWeixinUserInfo(snsAccessToken.getAccessToken(), snsAccessToken.getOpenid());

				}
//				
				this.getRequest().getSession().setAttribute("pwpSessionObjtest8", users2);
//
				this.redirect(toUrl + uidStr + userWechats.getWxOpenid());

				
			}
		} catch (Exception e) {
			// nothing
//			this.redirect("http://www.pacsonline.cn");
			this.renderText(e.toString());
		}
		
	}
	
}
